var debug = true;

System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = settingsClosed;	
	
//var urlLink = "http://www.ccc-mannheim.de/presence/roomState/getState?appKey=d41d8cd98f00b204e9800998ecf8427e";
var urlLink = "http://www.c3ma.de/roomstate/state.xml";

var _updateTimeS = 10;


function alert(msg)
{
    if (debug)
    {
        System.Debug.outputString(msg);
    }
}


function $(id) 
{
	return document.getElementById(id);
}

function GetRandom( min, max ) 
{
	if( min > max ) {
	return( -1 );
	}
	if( min == max ) {
	return( min );
	}
	return min + parseInt( Math.random() * ( max-min+1 ));
}

function ShowOpen()
{
    $('stateOpen').innerText = "OPEN";
}

function ShowClosed()
{
    $('stateOpen').innerText = "CLOSED";
}

function ShowFailed()
{
    $('stateOpen').innerText = "FAIL";
}

function ShowOffline()
{
    $('stateOpen').innerText = "OFFLINE";
    ShowTemperature("UNDEFINED", "UNDEFINED");
}

function ShowUndefined()
{
    $('stateOpen').innerText = "UNDEFINED";
}

function ShowTemperature(innenTemp, aussenTemp){
     $('innenTemp').innerText = innenTemp + " C";
     $('aussenTemp').innerText = aussenTemp + " C";
}

function checkConnectivity() 
{
    alert("checkConnectivity");
  try
  { 
	 xmlhttp=new XMLHttpRequest();
	 requestLink = urlLink + "?" + GetRandom(0,5000000000);
	 requestLink = requestLink + "&" + GetRandom(0,7000000000);
	 requestLink = requestLink + "&" + GetRandom(0,6000000000);		
     xmlhttp.open('GET', requestLink, true);		
	 xmlhttp.onreadystatechange = function () {		
		if (xmlhttp.readyState  == 4) 
		{				
			//var responseWords = xmlhttp.responseText.split(" ");
			if(xmlhttp.status == 200){
			    //die xml antwort auswerten
			    evaluateStateXML(xmlhttp.responseXML);			    			   			 
			
//				if(responseWords[0] == "OPEN")
//				{
//				    ShowOpen();
//				}
//				else if(responseWords[0] == "CLOSED")
//				{
//				    ShowClosed();
//				}					
			}
			else
			{
				//if(responseWords[0] == "FAILED"){
			//	    ShowFailed();
				//}else 
//				{
				    ShowOffline();
//				}
			}
		}
	};
	xmlhttp.send(null);
  }catch(e){
	alert(e);
  }
}

function evaluateStateXML(xml)
{
    try{
        var status = xml.getElementsByTagName("status")[0].firstChild.nodeValue;
        if(status == "1"){
            ShowOpen();
        }
        else if(status == "0"){
            ShowClosed();
        }
        else{
            ShowUndefined();
        }
    }catch(e){
        ShowUndefined();
    }
    
    try{       
        var innenTemp = xml.getElementsByTagName("innen")[0].firstChild.nodeValue;
        var aussenTemp = xml.getElementsByTagName("aussen")[0].firstChild.nodeValue;
        ShowTemperature(innenTemp, aussenTemp);
    }catch(e){  
        ShowTemperature("UNDEFINED", "UNDEFINED");  
    }
}



function settingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
        initializeFromSettings();
    }
}

var intervalHandler;

function initializeFromSettings(){
    
        _updateTimeS = parseInt(System.Gadget.Settings.read("updateTimeText")); 
       
        checkConnectivity();
        window.clearInterval(intervalHandler);
        intervalHandler = window.setInterval(checkConnectivity, _updateTimeS * 1000);
}



function init() {	
    //initialize the settings
    var tmp = System.Gadget.Settings.read("updateTimeText");
    if(tmp == undefined || tmp == ""){
        System.Gadget.Settings.write("updateTimeText", _updateTimeS);
    }    
    
    initializeFromSettings();
}


function onFlyout1Click()
{
    System.Gadget.Flyout.file = "flyout1.html";
    
    if (System.Gadget.Flyout.show == false)
    {
        flyout1open = true;
        System.Gadget.Flyout.show = true;
        alert("flyout1 shown");
    }else{
        flyout1open = false;
        System.Gadget.Flyout.show = false;
        alert("flyout1 hidden");
    }
}

function onFlyout2Click()
{   
    System.Gadget.Flyout.file = "flyout2.html";
    
    if (System.Gadget.Flyout.show == false)
    {
        flyout2open = true;
        System.Gadget.Flyout.show = true;
        alert("flyout2 shown");
    }else{
        flyout2open = false;
        System.Gadget.Flyout.show = false;
        alert("flyout2 hidden");
    }
}